#
# Programa de teste para MIPS com perifrico de transmisso serial
# Author: Ney Laert Vilar Calazans
#

	.text   
	.globl  main		# Declare the label main to be a global one
main:	
	la      $t0, sr_add	# Obtm endereo do endereo inicial do transmissor
	lw	$s0,0($t0)	# $s0 contm endereo do transmissor
	la      $t1, wd_tx	# Obtm endereo de nmero de palavras
	lw      $t1, 0($t1)	# $t1 contm nmero de palavras
        			# deve ser entre 1 e 4
	sw	$t1,0($s0)	# Escreve no perifrico o nmero  de palavras que vai enviar
	la      $t2, words	# Obtm endereo de nmero de palavras

loop:	blez	$t1,fim		# Se contador de palavras  0, fim
	lw	$t3,0($t2)	# Seno $t3 tem palavra a enviar
	addiu	$s0,1		# Incrementa endereo de escrita do perifrico
# ATENO!! Trocar 1 para 4 na execuo em SW (Porqu?)
	sw	$t3,0($s0)	# Escreve palavra a enviar
	addiu	$t1,-1		# Decrementa contador de palavras
	addiu	$t2,4		# Incrementa ponteiro para palavras
	j	loop		# Continua o lao
	
fim:	lw	$s0,0($t0)	# recupera endereo do transmissor
	lui	$t3,0		
	ori	$t3,1		# gera constante 1
	sw	$t3,5($s0)	# Escreve constante 1 no reg 5 do perifrico, ou seja,
				# comando para transmissor iniciar a transmisso serial
# ATENO!! Trocar 5 para 20 na execuo em SW (Porqu?)
espera:	lw	$t4,0($s0)	# L sinal ready
	blez	$t4,espera	# Fica lendo at ready=1
# ATENO!! na execuo do software, sempre se cai fora deste lao na primeira volta (Porqu?)
	
	sw	$zero,5($s0)	# Depois que transmisso terminou, cancela pedido,
				# escrevendo 0 no reg 5 do perifrico
# ATENO!! Trocar 5 para 20 na execuo em SW (Porqu?)
				
aqui:	j       aqui		# Terminou, entra em loop


        .data  
sr_add:	.word	0x10010060
wd_tx:  .word   0x4        
words:  .word   0xFFFFFFFF, 0x12345678, 0x9ABCDEF0, 0x55555555
